#!/usr/bin/perl

use XML::Simple;
use Data::Dumper;

if (! -f $ARGV[0]) {
	print (STDERR "xml2xgmml [file]\n");
	exit 1;
}

$data = XMLin ($ARGV[0]);

print ("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
print ("<graph id=\"xxx\" label=\"xxx\" xmlns=\"http://www.cs.rpi.edu/XGMML\">\n");
print ("<att name=\"documentVersion\" value=\"1.0\"/>");

$el = $data->{entry};
foreach (keys (%{$el})) {
	$entry_id = $_;
	$app_name = $el->{$_}->{app_name};
	$url_path = $el->{$_}->{url_path};
	$stare = $el->{$_}->{stare_count};
	$title = $el->{$_}->{title};
	
	print ("<node id=\"$entry_id\" label=\"$title\">\n");
	print ("<att label=\"app_name\" name=\"app_name\" value=\"$app_name\" type=\"string\"/>\n");
	print ("<att label=\"url_path\" name=\"url_path\" value=\"$url_path\" type=\"string\"/>\n");
	print ("<att label=\"title\" name=\"title\" value=\"$title\" type=\"string\"/>\n");
	print ("<att label=\"stare\" name=\"stare\" value=\"$stare.0\" type=\"real\"/>\n");
	print ("</node>\n");
}

$el = $data->{relationships}->{entry};

foreach (@{$el}) {
	$from = $_->{from_id};
	$to = $_->{to_id};
	$count = $_->{switch_count};
	
	print ("<edge id=\"$from-$to\" label=\"$from\" source=\"$from\" target=\"$to\">\n");
	print ("<att label=\"count\" name=\"count\" value=\"$count.0\" type=\"real\"/>\n");
	print ("</edge>\n");
}


print ("</graph>\n");
